' Copyright (c) 2007-2022 Bruce A Henderson
' 
' Permission is hereby granted, free of charge, to any person obtaining a copy
' of this software and associated documentation files (the "Software"), to deal
' in the Software without restriction, including without limitation the rights
' to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
' copies of the Software, and to permit persons to whom the Software is
' furnished to do so, subject to the following conditions:
' 
' The above copyright notice and this permission notice shall be included in
' all copies or substantial portions of the Software.
' 
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
' IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
' FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
' AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
' LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
' OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
' THE SOFTWARE.

SuperStrict

Import Net.libssh2
Import Net.mbedtls
Import "../mbedtls.mod/mbedtls/include/*.h"

Import "../libssh2.mod/libssh2/src/*.h"
Import "../libssh2.mod/libssh2/include/*.h"

'Import "c-ares/include/*.h"

Import "libcurl/lib/*.h"
Import "libcurl/include/*.h"

Import "libcurl/lib/altsvc.c"
Import "libcurl/lib/amigaos.c"
Import "libcurl/lib/asyn-ares.c"
Import "libcurl/lib/asyn-thread.c"
Import "libcurl/lib/base64.c"
Import "libcurl/lib/bufref.c"
Import "libcurl/lib/c-hyper.c"
Import "libcurl/lib/conncache.c"
Import "libcurl/lib/connect.c"
Import "libcurl/lib/content_encoding.c"
Import "libcurl/lib/cookie.c"
Import "libcurl/lib/curl_addrinfo.c"
Import "libcurl/lib/curl_ctype.c"
Import "libcurl/lib/curl_des.c"
Import "libcurl/lib/curl_endian.c"
Import "libcurl/lib/curl_fnmatch.c"
Import "libcurl/lib/curl_get_line.c"
Import "libcurl/lib/curl_gethostname.c"
Import "libcurl/lib/curl_gssapi.c"
Import "libcurl/lib/curl_memrchr.c"
Import "libcurl/lib/curl_multibyte.c"
Import "libcurl/lib/curl_ntlm_core.c"
Import "libcurl/lib/curl_ntlm_wb.c"
Import "libcurl/lib/curl_path.c"
Import "libcurl/lib/curl_range.c"
Import "libcurl/lib/curl_rtmp.c"
Import "libcurl/lib/curl_sasl.c"
Import "libcurl/lib/curl_sspi.c"
Import "libcurl/lib/curl_threads.c"
Import "libcurl/lib/dict.c"
Import "libcurl/lib/doh.c"
Import "libcurl/lib/dotdot.c"
Import "libcurl/lib/dynbuf.c"
Import "libcurl/lib/easy.c"
Import "libcurl/lib/easygetopt.c"
Import "libcurl/lib/easyoptions.c"
Import "libcurl/lib/escape.c"
Import "libcurl/lib/file.c"
Import "libcurl/lib/fileinfo.c"
Import "libcurl/lib/formdata.c"
Import "libcurl/lib/ftp.c"
Import "libcurl/lib/ftplistparser.c"
Import "libcurl/lib/getenv.c"
Import "libcurl/lib/getinfo.c"
Import "libcurl/lib/gopher.c"
Import "libcurl/lib/hash.c"
Import "libcurl/lib/hmac.c"
Import "libcurl/lib/hostasyn.c"
Import "libcurl/lib/hostcheck.c"
Import "libcurl/lib/hostip.c"
Import "libcurl/lib/hostip4.c"
Import "libcurl/lib/hostip6.c"
Import "libcurl/lib/hostsyn.c"
Import "libcurl/lib/hsts.c"
Import "libcurl/lib/http.c"
Import "libcurl/lib/http2.c"
Import "libcurl/lib/http_aws_sigv4.c"
Import "libcurl/lib/http_chunks.c"
Import "libcurl/lib/http_digest.c"
Import "libcurl/lib/http_negotiate.c"
Import "libcurl/lib/http_ntlm.c"
Import "libcurl/lib/http_proxy.c"
Import "libcurl/lib/idn_win32.c"
Import "libcurl/lib/if2ip.c"
Import "libcurl/lib/imap.c"
Import "libcurl/lib/inet_ntop.c"
Import "libcurl/lib/inet_pton.c"
Import "libcurl/lib/krb5.c"
Import "libcurl/lib/ldap.c"
Import "libcurl/lib/llist.c"
Import "libcurl/lib/md4.c"
Import "libcurl/lib/md5.c"
Import "libcurl/lib/memdebug.c"
Import "libcurl/lib/mime.c"
Import "libcurl/lib/mprintf.c"
Import "libcurl/lib/mqtt.c"
Import "libcurl/lib/multi.c"
Import "libcurl/lib/netrc.c"
Import "libcurl/lib/non-ascii.c"
Import "libcurl/lib/nonblock.c"
Import "libcurl/lib/nwlib.c"
Import "libcurl/lib/nwos.c"
Import "libcurl/lib/openldap.c"
Import "libcurl/lib/parsedate.c"
Import "libcurl/lib/pingpong.c"
Import "libcurl/lib/pop3.c"
Import "libcurl/lib/progress.c"
Import "libcurl/lib/psl.c"
Import "libcurl/lib/rand.c"
Import "libcurl/lib/rename.c"
Import "libcurl/lib/rtsp.c"
Import "libcurl/lib/select.c"
Import "libcurl/lib/sendf.c"
Import "libcurl/lib/setopt.c"
Import "libcurl/lib/sha256.c"
Import "libcurl/lib/share.c"
Import "libcurl/lib/slist.c"
Import "libcurl/lib/smb.c"
Import "libcurl/lib/smtp.c"
Import "libcurl/lib/socketpair.c"
Import "libcurl/lib/socks.c"
Import "libcurl/lib/socks_gssapi.c"
Import "libcurl/lib/socks_sspi.c"
Import "libcurl/lib/speedcheck.c"
Import "libcurl/lib/splay.c"
Import "libcurl/lib/strcase.c"
Import "libcurl/lib/strdup.c"
Import "libcurl/lib/strerror.c"
Import "libcurl/lib/strtok.c"
Import "libcurl/lib/strtoofft.c"
Import "libcurl/lib/system_win32.c"
Import "libcurl/lib/telnet.c"
Import "libcurl/lib/tftp.c"
Import "libcurl/lib/timeval.c"
Import "libcurl/lib/transfer.c"
Import "libcurl/lib/url.c"
Import "libcurl/lib/urlapi.c"
Import "libcurl/lib/version.c"
Import "libcurl/lib/version_win32.c"
Import "libcurl/lib/warnless.c"
Import "libcurl/lib/wildcard.c"
Import "libcurl/lib/x509asn1.c"

Import "libcurl/lib/vauth/cleartext.c"
Import "libcurl/lib/vauth/cram.c"
Import "libcurl/lib/vauth/digest.c"
Import "libcurl/lib/vauth/digest_sspi.c"
Import "libcurl/lib/vauth/gsasl.c"
Import "libcurl/lib/vauth/krb5_gssapi.c"
Import "libcurl/lib/vauth/krb5_sspi.c"
Import "libcurl/lib/vauth/ntlm.c"
Import "libcurl/lib/vauth/ntlm_sspi.c"
Import "libcurl/lib/vauth/oauth2.c"
Import "libcurl/lib/vauth/spnego_gssapi.c"
Import "libcurl/lib/vauth/spnego_sspi.c"
Import "libcurl/lib/vauth/vauth.c"

Import "libcurl/lib/vtls/bearssl.c"
Import "libcurl/lib/vtls/gskit.c"
Import "libcurl/lib/vtls/gtls.c"
Import "libcurl/lib/vtls/keylog.c"
Import "libcurl/lib/vtls/mbedtls.c"
Import "libcurl/lib/vtls/mbedtls_threadlock.c"
Import "libcurl/lib/vtls/mesalink.c"
Import "libcurl/lib/vtls/nss.c"
Import "libcurl/lib/vtls/openssl.c"
Import "libcurl/lib/vtls/rustls.c"
Import "libcurl/lib/vtls/schannel.c"
Import "libcurl/lib/vtls/schannel_verify.c"
Import "libcurl/lib/vtls/sectransp.c"
Import "libcurl/lib/vtls/vtls.c"
Import "libcurl/lib/vtls/wolfssl.c"

' ares
rem
Import "c-ares/src/lib/ares__addrinfo2hostent.c"
Import "c-ares/src/lib/ares__addrinfo_localhost.c"
Import "c-ares/src/lib/ares__close_sockets.c"
Import "c-ares/src/lib/ares__get_hostent.c"
Import "c-ares/src/lib/ares__parse_into_addrinfo.c"
Import "c-ares/src/lib/ares__read_line.c"
Import "c-ares/src/lib/ares__readaddrinfo.c"
Import "c-ares/src/lib/ares__sortaddrinfo.c"
Import "c-ares/src/lib/ares__timeval.c"
Import "c-ares/src/lib/ares_android.c"
Import "c-ares/src/lib/ares_cancel.c"
Import "c-ares/src/lib/ares_create_query.c"
Import "c-ares/src/lib/ares_data.c"
Import "c-ares/src/lib/ares_destroy.c"
Import "c-ares/src/lib/ares_expand_name.c"
Import "c-ares/src/lib/ares_expand_string.c"
Import "c-ares/src/lib/ares_fds.c"
Import "c-ares/src/lib/ares_free_hostent.c"
Import "c-ares/src/lib/ares_free_string.c"
Import "c-ares/src/lib/ares_freeaddrinfo.c"
Import "c-ares/src/lib/ares_getaddrinfo.c"
Import "c-ares/src/lib/ares_getenv.c"
Import "c-ares/src/lib/ares_gethostbyaddr.c"
Import "c-ares/src/lib/ares_gethostbyname.c"
Import "c-ares/src/lib/ares_getnameinfo.c"
Import "c-ares/src/lib/ares_getsock.c"
Import "c-ares/src/lib/ares_init.c"
Import "c-ares/src/lib/ares_library_init.c"
Import "c-ares/src/lib/ares_llist.c"
Import "c-ares/src/lib/ares_mkquery.c"
Import "c-ares/src/lib/ares_nowarn.c"
Import "c-ares/src/lib/ares_options.c"
Import "c-ares/src/lib/ares_parse_a_reply.c"
Import "c-ares/src/lib/ares_parse_aaaa_reply.c"
Import "c-ares/src/lib/ares_parse_caa_reply.c"
Import "c-ares/src/lib/ares_parse_mx_reply.c"
Import "c-ares/src/lib/ares_parse_naptr_reply.c"
Import "c-ares/src/lib/ares_parse_ns_reply.c"
Import "c-ares/src/lib/ares_parse_ptr_reply.c"
Import "c-ares/src/lib/ares_parse_soa_reply.c"
Import "c-ares/src/lib/ares_parse_srv_reply.c"
Import "c-ares/src/lib/ares_parse_txt_reply.c"
Import "c-ares/src/lib/ares_parse_uri_reply.c"
Import "c-ares/src/lib/ares_platform.c"
Import "c-ares/src/lib/ares_process.c"
Import "c-ares/src/lib/ares_query.c"
Import "c-ares/src/lib/ares_search.c"
Import "c-ares/src/lib/ares_send.c"
Import "c-ares/src/lib/ares_strcasecmp.c"
Import "c-ares/src/lib/ares_strdup.c"
Import "c-ares/src/lib/ares_strerror.c"
Import "c-ares/src/lib/ares_strsplit.c"
Import "c-ares/src/lib/ares_timeout.c"
Import "c-ares/src/lib/ares_version.c"
Import "c-ares/src/lib/ares_writev.c"
Import "c-ares/src/lib/bitncmp.c"
Import "c-ares/src/lib/inet_net_pton.c"
Import "c-ares/src/lib/inet_ntop.c"
Import "c-ares/src/lib/windows_port.c"
end rem
